NX Open C++ Reference Guide
Public Types | Public Member Functions | List of all members
NXOpen::Routing::SplinePathBuilder Class Reference

Represents a NXOpen::Routing::SplinePathBuilder object. More...

Inheritance diagram for NXOpen::Routing::SplinePathBuilder:
NXOpen::Builder NXOpen::TaggedObject NXOpen::GeometricUtilities::IComponentBuilder

Public Types

enum  DefiningPointMethod { DefiningPointMethodCreatePoint, DefiningPointMethodUseExisting }
 Specifies if a new point should be created when adding a point to the spline. More...
 
enum  DefiningTypes {
  DefiningTypesUnsupported, DefiningTypesInterpolation, DefiningTypesParametric, DefiningTypesBezier,
  DefiningTypesBezierSlack, DefiningTypesBezierMaxCurvature
}
 Specifies how the spline points define the shape of the spline. More...
 
enum  DragMode { DragModeActive, DragModeInactive }
 Specifies if drag network is active when updating the position of a defining point. More...
 
enum  SplinePathAttributeOptions { SplinePathAttributeOptionsRadius, SplinePathAttributeOptionsRatioToDiameter }
 Describes user attribute methods options. More...
 
enum  SplinePathRadiusSource { SplinePathRadiusSourceExpression, SplinePathRadiusSourceRatioToDiameter, SplinePathRadiusSourceAttribute }
 Describes the method for the constrained curvature spline to be defined as. More...
 
enum  SplinePathSlackType { SplinePathSlackTypePercentLength, SplinePathSlackTypeAdditionalLength, SplinePathSlackTypeLockLength, SplinePathSlackTypeUndefined }
 Describes the type of slack to be applied to the spline. More...
 

Public Member Functions

void AddDefiningPointAtAbsoluteCoords (const NXOpen::Point3d &point)
 Adds a point to the spline. More...
 
int AddDefiningPointToSpline (NXOpen::Point *point, bool createNewPoint)
 Adds a defining point to the current spline or creates the first point of the new spline. More...
 
void AddSlackToSpline (NXOpen::Routing::SplinePathBuilder::SplinePathSlackType slackType, NXOpen::Expression *slackValue, NXOpen::Direction *slackDirection)
 
Created in NX6.0.0. More...
 
void AskDefiningData (std::vector< NXOpen::Point * > &points)
 When a spline is selected for editing, the builder will analyze the spline and gather all of the defining data. More...
 
void AssignExtension (int pointIndex, NXOpen::Direction *direction, NXOpen::Expression *forwardLength, NXOpen::Expression *backwardLength)
 Assigns an extension to the point at pointIndex. More...
 
void AssignExtension (int pointIndex, NXOpen::Direction *direction, NXOpen::Expression *forwardLength, NXOpen::Expression *backwardLength, bool forceDeleteOnZeroExpression)
 Assigns an extension to the point at pointIndex. More...
 
void AssignHealPathExtension (int pointIndex, NXOpen::Direction *direction, NXOpen::Expression *forwardLength, NXOpen::Expression *backwardLength)
 Assigns an extension to the point at pointIndex for Heal Path. More...
 
void AssignTangentExtensionForPointAtIndex (int index, NXOpen::Expression *forwardLength, NXOpen::Expression *backwardLength, NXOpen::Vector3d *tangent, NXOpen::Vector3d *normal, NXOpen::Direction **extensionDir)
 Assigns the extension direction and expressions tangent to the spline path at the given point index. More...
 
NXOpen::Routing::StockBlankStockAndGetLargestDia ()
 Blanks all the stocks on the current segment and returns the stock with the largest diameter. More...
 
bool BoundedCurvature ()
 Returns whether the spline maximum bounded radius value should be used. More...
 
NXOpen::ExpressionBoundedCurvatureRadius ()
 Returns the minimum radius allowed for this spline. More...
 
NXOpen::ExpressionBoundedCurvatureRatio ()
 Returns the minimum radius allowed for this spline as a ratio to diameter. More...
 
void CommitDrag (NXOpen::Point *definingPoint)
 Clears the current drag network. More...
 
NXOpen::Routing::AssignTangencyBuilderCreateAssignTangencyBuilder ()
 Creates a NXOpen::Routing::AssignTangencyBuilder object. More...
 
NXOpen::Routing::SplinePathBuilder::DefiningTypes DefiningType ()
 Returns the type which specifies the shape of the spline. More...
 
void DeleteDefiningPointAtIndex (int index)
 Deletes a defining point from the spline. More...
 
void DetachPoint (int index)
 Detaches the point at the selected index from all objects its attached to using a Touch constraint. More...
 
NXOpen::Routing::AssignTangencyBuilderGetAssignTangencyBuilder ()
 Get a NXOpen::Routing::AssignTangencyBuilder object. More...
 
void GetDefiningPointPositions (std::vector< double > &pointPositions)
 Gets the positions of the defining points as an array of doubles. More...
 
void GetDefiningPointPositionsAsPoints (std::vector< NXOpen::Point3d > &pointPositions)
 Gets the positions of the defining points as an array of Point3d coordinates. More...
 
void GetExtensionDataForPointAtIndex (int index, NXOpen::Expression **forwardLength, NXOpen::Expression **backwardLength, NXOpen::Vector3d *extDirection)
 Get the extension expressions at the given index. More...
 
NXOpen::Routing::StockGetLargestDiameterStock ()
 Returns the stock with the largest on the current segment. More...
 
double GetLockedSplineMinimumLength ()
 Returns the minimum length of the spline. More...
 
void GetOffsetData (int index, int *method, NXOpen::Point **basePoint, NXOpen::Direction **offDir, NXString *exp)
 Returns the Stock Offset data associated with a given point. More...
 
NXOpen::CurveGetRouteSegment ()
 Gets the routing segment managed by the builder, if it exists. More...
 
double GetSplineLength ()
 Gets the current length of the spline. More...
 
double GetSplineLengthNoShaping ()
 Gets the current length of the spline without shaping applied. More...
 
NXOpen::Routing::ControlPointGetStartAndEndRcp (NXOpen::Routing::ControlPoint **startRcp)
 Gets the RCPs managed by the builder, if they exist. More...
 
void InitializeDrag (int index)
 Initialize the D-Cubed dragging functionality for the point at index. More...
 
void IsLengthLocked (NXOpen::Expression **length, bool *isLocked, NXOpen::Direction **slackDirection)
 Is the spline length locked?
Created in NX6.0.0. More...
 
void IsSplineSlacked (bool *slacked, NXOpen::Routing::SplinePathBuilder::SplinePathSlackType *slackType, NXOpen::Expression **slackValue, NXOpen::Direction **downDir)
 
Created in NX6.0.0. More...
 
void LockSplineLengthNoShaping (NXOpen::Expression *length)
 Locks the length of the current spline. More...
 
void LockSplineLengthWithShaping (NXOpen::Expression *length, NXOpen::Direction *slackDirection)
 Locks the length of the current spline. More...
 
NXOpen::ExpressionMinimumCheckingAllowableRatio ()
 Returns the minimum ratio allowed for this spline
Created in NX9.0.1. More...
 
NXOpen::ExpressionMinimumCheckingAllowableValue ()
 Returns the minimum radius allowed for this spline. More...
 
NXOpen::Routing::SplinePathBuilder::SplinePathAttributeOptions MinimumCheckingMethod ()
 Returns the minimum checking method for this spline. More...
 
NXOpen::Routing::SplinePathBuilder::SplinePathRadiusSource RadiusSource ()
 Returns the driving expression, value, or attribute of the bounded radius. More...
 
void RemoveAllShaping ()
 Removes all shaping applied to the spline (Lock length, slacking). More...
 
void SetAddPointsOnSubdivideFlag (bool addPoints)
 Sets whether or not additional points will be added to a spline which is created as the result of a subdivide. More...
 
void SetBoundedCurvature (bool useBoundedCurvature)
 Sets whether the spline maximum bounded radius value should be used. More...
 
void SetCreateTangencyFlag (bool createTangency)
 Sets whether or not additional the newly created spline will be made tangent to connecting splines. More...
 
void SetDefaultPortExtensionLength (double value)
 Sets the default port extension length to be used when creating or editing points at port locations that do not already have an extension . More...
 
void SetDefiningType (NXOpen::Routing::SplinePathBuilder::DefiningTypes definingType)
 Sets the type which specifies the shape of the spline. More...
 
void SetLockToSelectedFlag (bool lockSelected)
 Sets whether the spline will attempt to lock points to selected object. More...
 
void SetMinimumCheckingMethod (NXOpen::Routing::SplinePathBuilder::SplinePathAttributeOptions routeCheckingMethod)
 Sets the minimum checking method for this spline. More...
 
void SetRadiusSource (NXOpen::Routing::SplinePathBuilder::SplinePathRadiusSource source)
 Sets the driving expression, value, or attribute of the bounded radius. More...
 
void SetShowSplineMinimumRadius (bool allowDisplay)
 Sets whether the spline minimum radius value should be displayed or not. More...
 
void SetSplineMethod (NXOpen::Positioning::Constraint::SplineType splineMethod)
 Sets the defining method of the spline. More...
 
void SetStockBoundedDiameter (double value)
 Sets the driving diameter of the current stock for the ratio-to-diameter bounded curvature. More...
 
void SetUseMinimumCheckingValue (bool useMinRadius)
 Sets whether the spline minimum radius value should be checked or not on this spline. More...
 
bool ShowSplineMinimumRadius ()
 Returns whether the spline minimum radius value should be displayed or not. More...
 
void UnblankStocks ()
 Unblanks stocks which were blanked by calling BlankStockAndGetLargestDia
More...
 
void UpdateDefiningPoint (int index, NXOpen::Point *point, bool inDrag, const NXOpen::Vector3d &translation)
 Updates the position of a point on the spline. More...
 
void UpdateDefiningPointPositionAtIndex (int index, NXOpen::Point *point, bool inDrag)
 Updates the position of a point on the spline. More...
 
void UpdateExtensionDirectionAtIndex (int index, const NXOpen::Vector3d &direction)
 Update the extension orientation at the point index. More...
 
void UpdateExtensionDirectionForPointAtIndex (int index, const NXOpen::Vector3d &deltaTrans, const NXOpen::Matrix3x3 &orientation, bool inDrag)
 Update the extension orientation at the point index. More...
 
bool UseMinimumCheckingValue ()
 Returns whether the spline minimum radius value should be checked or not on this spline. More...
 
- Public Member Functions inherited from NXOpen::Builder
NXOpen::NXObjectCommit ()
 Commits any edits that have been applied to the builder. More...
 
void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
std::vector< NXOpen::NXObject * > GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
NXOpen::NXObjectGetObject ()
 Returns the object currently being edited by this builder. More...
 
void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
virtual bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen::TaggedObject
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

Represents a NXOpen::Routing::SplinePathBuilder object.

The builder allows for creating and editing D-Cubed constrained splines, adding extensions, adding stock offset points, adding stock, locking length, adding slack, and locking to other D-Cubed constrained objects.
To create a new instance of this class, use NXOpen::Routing::RouteManager::CreateSplinePathBuilder

Created in NX6.0.0.

Member Enumeration Documentation

Specifies if a new point should be created when adding a point to the spline.

Enumerator
DefiningPointMethodCreatePoint 

create point

DefiningPointMethodUseExisting 

use existing

Specifies how the spline points define the shape of the spline.

Enumerator
DefiningTypesUnsupported 

The defining type is unsupported.

DefiningTypesInterpolation 

The defining type represents a C1-continuous, interpolation spline.

DefiningTypesParametric 

The defining type represents a G1-continuous, parametric curve.

DefiningTypesBezier 

The defining type represents a G1-continuous, piecewise cubic Bezier.

DefiningTypesBezierSlack 

The defining type represents a G1-continuous, piecewise cubic Bezier with pseudo gravity slack.

DefiningTypesBezierMaxCurvature 

The defining type represents a G1-continuous, piecewise cubic Bezier with bounded maximum curvature.

Specifies if drag network is active when updating the position of a defining point.

Enumerator
DragModeActive 

The drag network is active.

DragModeInactive 

The drag network is inactive.

Describes user attribute methods options.

These value are used to set minimum checking method. If checking method is ratio to diameter than allowable radius will be computed by ratioToDiameter x Stock Diameter.

Enumerator
SplinePathAttributeOptionsRadius 

A radius method option for spline user attribute.

SplinePathAttributeOptionsRatioToDiameter 

A ratio to diameter method option for spline user attribute.

Describes the method for the constrained curvature spline to be defined as.

Enumerator
SplinePathRadiusSourceExpression 

Specify radius by value.

SplinePathRadiusSourceRatioToDiameter 

Specify radius by ratio to stock.

SplinePathRadiusSourceAttribute 

Specify radius by attribute.

Describes the type of slack to be applied to the spline.

Enumerator
SplinePathSlackTypePercentLength 

The length of the spline is increased by a percentage of the spline length.

SplinePathSlackTypeAdditionalLength 

The length of the spline is increased by an additional length.

SplinePathSlackTypeLockLength 

The length of the spline is slacking to a specified and locked length.

SplinePathSlackTypeUndefined 

Slack length is undefined.

Member Function Documentation

void NXOpen::Routing::SplinePathBuilder::AddDefiningPointAtAbsoluteCoords ( const NXOpen::Point3d point)

Adds a point to the spline.

The point will be the new endpoint of the spline.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
pointThe Point to add.
int NXOpen::Routing::SplinePathBuilder::AddDefiningPointToSpline ( NXOpen::Point point,
bool  createNewPoint 
)

Adds a defining point to the current spline or creates the first point of the new spline.

Returns
Returns the index the point was added along the spline. For example, if 3 points exist on the spline and the new point was added between points 0 and 1 this variable would be set to 1.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
pointPoint to add.
createNewPointShould the builder create a new point based on the one provided?
void NXOpen::Routing::SplinePathBuilder::AddSlackToSpline ( NXOpen::Routing::SplinePathBuilder::SplinePathSlackType  slackType,
NXOpen::Expression slackValue,
NXOpen::Direction slackDirection 
)


Created in NX6.0.0.



License requirements : routing_base ("Routing Basic")

Parameters
slackTypeThe type of slack to add.
slackValueThe amount of slack to add.
slackDirectionThe direction to apply slack.
void NXOpen::Routing::SplinePathBuilder::AskDefiningData ( std::vector< NXOpen::Point * > &  points)

When a spline is selected for editing, the builder will analyze the spline and gather all of the defining data.

The dialog will use this function to retrieve the defining data from the builder to populate its fields.
Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
pointsDefining points of the spline.
void NXOpen::Routing::SplinePathBuilder::AssignExtension ( int  pointIndex,
NXOpen::Direction direction,
NXOpen::Expression forwardLength,
NXOpen::Expression backwardLength 
)

Assigns an extension to the point at pointIndex.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
pointIndexIndex of the point to assing extension.
directionDirection of the extension.
forwardLengthForward Length of the extension.
backwardLengthBackward Length of the extension.
void NXOpen::Routing::SplinePathBuilder::AssignExtension ( int  pointIndex,
NXOpen::Direction direction,
NXOpen::Expression forwardLength,
NXOpen::Expression backwardLength,
bool  forceDeleteOnZeroExpression 
)

Assigns an extension to the point at pointIndex.


Created in NX11.0.1.

License requirements : routing_base ("Routing Basic")

Parameters
pointIndexIndex of the point to assign extension.
directionDirection of extension.
forwardLengthForward length of extension.
backwardLengthBackward length of extension.
forceDeleteOnZeroExpressionforcedeleteonzeroexpression
void NXOpen::Routing::SplinePathBuilder::AssignHealPathExtension ( int  pointIndex,
NXOpen::Direction direction,
NXOpen::Expression forwardLength,
NXOpen::Expression backwardLength 
)

Assigns an extension to the point at pointIndex for Heal Path.


Created in NX6.0.1.

License requirements : routing_base ("Routing Basic")

Parameters
pointIndexIndex of the point to assing extension.
directionDirection of the extension.
forwardLengthLength of the forward extension.
backwardLengthLength of the backward extension.
void NXOpen::Routing::SplinePathBuilder::AssignTangentExtensionForPointAtIndex ( int  index,
NXOpen::Expression forwardLength,
NXOpen::Expression backwardLength,
NXOpen::Vector3d tangent,
NXOpen::Vector3d normal,
NXOpen::Direction **  extensionDir 
)

Assigns the extension direction and expressions tangent to the spline path at the given point index.


Created in NX11.0.1.

License requirements : routing_base ("Routing Basic")

Parameters
indexIndex of the point to use.
forwardLengthLength of the forward extension.
backwardLengthLength of the backward extension.
tangentExtension direction.
normalCurve normal.
extensionDirDirection object.
NXOpen::Routing::Stock* NXOpen::Routing::SplinePathBuilder::BlankStockAndGetLargestDia ( )

Blanks all the stocks on the current segment and returns the stock with the largest diameter.

Returns
The stock with the largest diameter.
Deprecated:
Deprecated in NX12.0.0. Use Routing::SplinePathBuilder::GetLargestDiameterStock instead.


Created in NX7.5.1.

License requirements : routing_base ("Routing Basic")

bool NXOpen::Routing::SplinePathBuilder::BoundedCurvature ( )

Returns whether the spline maximum bounded radius value should be used.


Created in NX12.0.0.

License requirements : routing_advanced ("Routing Advanced")

NXOpen::Expression* NXOpen::Routing::SplinePathBuilder::BoundedCurvatureRadius ( )

Returns the minimum radius allowed for this spline.


Created in NX12.0.0.

License requirements : routing_advanced ("Routing Advanced")

NXOpen::Expression* NXOpen::Routing::SplinePathBuilder::BoundedCurvatureRatio ( )

Returns the minimum radius allowed for this spline as a ratio to diameter.


Created in NX12.0.0.

License requirements : routing_advanced ("Routing Advanced")

void NXOpen::Routing::SplinePathBuilder::CommitDrag ( NXOpen::Point definingPoint)

Clears the current drag network.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
definingPointOptional UI point defining the position of the spline point.
NXOpen::Routing::AssignTangencyBuilder* NXOpen::Routing::SplinePathBuilder::CreateAssignTangencyBuilder ( )

Creates a NXOpen::Routing::AssignTangencyBuilder object.

Returns

Created in NX12.0.0.

License requirements : routing_base ("Routing Basic")
NXOpen::Routing::SplinePathBuilder::DefiningTypes NXOpen::Routing::SplinePathBuilder::DefiningType ( )

Returns the type which specifies the shape of the spline.

See NXOpen::Routing::SplinePathBuilder::DefiningTypes for valid options
Created in NX12.0.0.

License requirements : routing_base ("Routing Basic")

void NXOpen::Routing::SplinePathBuilder::DeleteDefiningPointAtIndex ( int  index)

Deletes a defining point from the spline.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
indexIndex of the point to delete.
void NXOpen::Routing::SplinePathBuilder::DetachPoint ( int  index)

Detaches the point at the selected index from all objects its attached to using a Touch constraint.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
indexIndex of point to detach.
NXOpen::Routing::AssignTangencyBuilder* NXOpen::Routing::SplinePathBuilder::GetAssignTangencyBuilder ( )

Get a NXOpen::Routing::AssignTangencyBuilder object.

Returns

Created in NX12.0.0.

License requirements : routing_base ("Routing Basic")
void NXOpen::Routing::SplinePathBuilder::GetDefiningPointPositions ( std::vector< double > &  pointPositions)

Gets the positions of the defining points as an array of doubles.

Each point's XYZ coordinates are represented by three doubles. X1, Y1, Z1, X2, Y2, Z2, X3, Y3, Z3, ...


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
pointPositionsarray of doubles representing the defining points.
void NXOpen::Routing::SplinePathBuilder::GetDefiningPointPositionsAsPoints ( std::vector< NXOpen::Point3d > &  pointPositions)

Gets the positions of the defining points as an array of Point3d coordinates.


Created in NX11.0.2.

License requirements : routing_base ("Routing Basic")

Parameters
pointPositionsarray of points representing the defining points.
void NXOpen::Routing::SplinePathBuilder::GetExtensionDataForPointAtIndex ( int  index,
NXOpen::Expression **  forwardLength,
NXOpen::Expression **  backwardLength,
NXOpen::Vector3d extDirection 
)

Get the extension expressions at the given index.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
indexIndex of the defining point to query.
forwardLengthForward extension length.
backwardLengthBackward extension length.
extDirectionExtension direction.
NXOpen::Routing::Stock* NXOpen::Routing::SplinePathBuilder::GetLargestDiameterStock ( )

Returns the stock with the largest on the current segment.

Returns
The stock with the largest diameter.
Created in NX12.0.0.

License requirements : routing_base ("Routing Basic")
double NXOpen::Routing::SplinePathBuilder::GetLockedSplineMinimumLength ( )

Returns the minimum length of the spline.

The minimum length is the straight line distance between all defining points, including extensions.

Returns
The minimum length of the spline.
Created in NX7.5.4.

License requirements : routing_base ("Routing Basic")
void NXOpen::Routing::SplinePathBuilder::GetOffsetData ( int  index,
int *  method,
NXOpen::Point **  basePoint,
NXOpen::Direction **  offDir,
NXString exp 
)

Returns the Stock Offset data associated with a given point.

Output can be NULL if the associated point is not a stock offset point.
Created in NX6.0.1.

License requirements : routing_base ("Routing Basic")

Parameters
indexIndex of point to detach.
methodThe type of offset object. 0 = Not Offset, 1 = Stock Offset Point, 2 = Stock Offset Surface.
basePointThe base point frim the offset object.
offDirThe offset direction.
expThe expression defining the offset distance.
NXOpen::Curve* NXOpen::Routing::SplinePathBuilder::GetRouteSegment ( )

Gets the routing segment managed by the builder, if it exists.

Returns
Visible Routing BCurve Segment.
Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")
double NXOpen::Routing::SplinePathBuilder::GetSplineLength ( )

Gets the current length of the spline.

Returns
The length of the current spline.
Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")
double NXOpen::Routing::SplinePathBuilder::GetSplineLengthNoShaping ( )

Gets the current length of the spline without shaping applied.

Returns
The length of the current spline without shaping.
Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")
NXOpen::Routing::ControlPoint* NXOpen::Routing::SplinePathBuilder::GetStartAndEndRcp ( NXOpen::Routing::ControlPoint **  startRcp)

Gets the RCPs managed by the builder, if they exist.

Returns
The target ControlPoint.
Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")
Parameters
startRcpThe source ControlPoint.
void NXOpen::Routing::SplinePathBuilder::InitializeDrag ( int  index)

Initialize the D-Cubed dragging functionality for the point at index.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
indexIndex of the point to drag.
void NXOpen::Routing::SplinePathBuilder::IsLengthLocked ( NXOpen::Expression **  length,
bool *  isLocked,
NXOpen::Direction **  slackDirection 
)

Is the spline length locked?
Created in NX6.0.0.



License requirements : routing_base ("Routing Basic")

Parameters
lengthThe locked length of the spline.
isLockedIs the spline length locked?
slackDirectionThe direction to apply slack.
void NXOpen::Routing::SplinePathBuilder::IsSplineSlacked ( bool *  slacked,
NXOpen::Routing::SplinePathBuilder::SplinePathSlackType slackType,
NXOpen::Expression **  slackValue,
NXOpen::Direction **  downDir 
)


Created in NX6.0.0.



License requirements : routing_base ("Routing Basic")

Parameters
slackedIs slack applied to the spline?
slackTypeThe type of slack.
slackValueThe added amount of slack.
downDirThe slack direction.
void NXOpen::Routing::SplinePathBuilder::LockSplineLengthNoShaping ( NXOpen::Expression length)

Locks the length of the current spline.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
lengthThe length to lock the spline.
void NXOpen::Routing::SplinePathBuilder::LockSplineLengthWithShaping ( NXOpen::Expression length,
NXOpen::Direction slackDirection 
)

Locks the length of the current spline.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
lengthThe length to lock the spline.
slackDirectionThe direction to apply slack.
NXOpen::Expression* NXOpen::Routing::SplinePathBuilder::MinimumCheckingAllowableRatio ( )

Returns the minimum ratio allowed for this spline
Created in NX9.0.1.



License requirements : routing_base ("Routing Basic")

NXOpen::Expression* NXOpen::Routing::SplinePathBuilder::MinimumCheckingAllowableValue ( )

Returns the minimum radius allowed for this spline.


Created in NX9.0.1.

License requirements : routing_base ("Routing Basic")

NXOpen::Routing::SplinePathBuilder::SplinePathAttributeOptions NXOpen::Routing::SplinePathBuilder::MinimumCheckingMethod ( )

Returns the minimum checking method for this spline.

See NXOpen::Routing::SplinePathBuilder::SplinePathAttributeOptions for valid options
Created in NX9.0.1.

License requirements : routing_base ("Routing Basic")

NXOpen::Routing::SplinePathBuilder::SplinePathRadiusSource NXOpen::Routing::SplinePathBuilder::RadiusSource ( )

Returns the driving expression, value, or attribute of the bounded radius.


Created in NX12.0.0.

License requirements : routing_advanced ("Routing Advanced")

void NXOpen::Routing::SplinePathBuilder::RemoveAllShaping ( )

Removes all shaping applied to the spline (Lock length, slacking).


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

void NXOpen::Routing::SplinePathBuilder::SetAddPointsOnSubdivideFlag ( bool  addPoints)

Sets whether or not additional points will be added to a spline which is created as the result of a subdivide.

If true, new points will be added to maintain a shape similar to the original curve.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
addPointsTrue to add points to subdivided splines.
void NXOpen::Routing::SplinePathBuilder::SetBoundedCurvature ( bool  useBoundedCurvature)

Sets whether the spline maximum bounded radius value should be used.


Created in NX12.0.0.

License requirements : routing_advanced ("Routing Advanced")

Parameters
useBoundedCurvatureuseboundedcurvature
void NXOpen::Routing::SplinePathBuilder::SetCreateTangencyFlag ( bool  createTangency)

Sets whether or not additional the newly created spline will be made tangent to connecting splines.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
createTangencyTrue to add tangency.
void NXOpen::Routing::SplinePathBuilder::SetDefaultPortExtensionLength ( double  value)

Sets the default port extension length to be used when creating or editing points at port locations that do not already have an extension .


Created in NX12.0.0.

License requirements : routing_advanced ("Routing Advanced")

Parameters
valuevalue
void NXOpen::Routing::SplinePathBuilder::SetDefiningType ( NXOpen::Routing::SplinePathBuilder::DefiningTypes  definingType)

Sets the type which specifies the shape of the spline.

See NXOpen::Routing::SplinePathBuilder::DefiningTypes for valid options
Created in NX12.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
definingTypedefiningtype
void NXOpen::Routing::SplinePathBuilder::SetLockToSelectedFlag ( bool  lockSelected)

Sets whether the spline will attempt to lock points to selected object.

This flag is only checked when adding a point to a spline by passing in a smart point to derive a new dumb spline point from. If the smart point is derived from a Port, ControlPoint, or other Routing Object, the new spline defining point will lock to that object. This flag is also checked during commit, where endpoint associativity is applied.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
lockSelectedTrue to lock to selected objects.
void NXOpen::Routing::SplinePathBuilder::SetMinimumCheckingMethod ( NXOpen::Routing::SplinePathBuilder::SplinePathAttributeOptions  routeCheckingMethod)

Sets the minimum checking method for this spline.

See NXOpen::Routing::SplinePathBuilder::SplinePathAttributeOptions for valid options
Created in NX9.0.1.

License requirements : routing_base ("Routing Basic")

Parameters
routeCheckingMethodroutecheckingmethod
void NXOpen::Routing::SplinePathBuilder::SetRadiusSource ( NXOpen::Routing::SplinePathBuilder::SplinePathRadiusSource  source)

Sets the driving expression, value, or attribute of the bounded radius.


Created in NX12.0.0.

License requirements : routing_advanced ("Routing Advanced")

Parameters
sourceThe type of bounded curvature.
void NXOpen::Routing::SplinePathBuilder::SetShowSplineMinimumRadius ( bool  allowDisplay)

Sets whether the spline minimum radius value should be displayed or not.


Created in NX9.0.1.

License requirements : routing_base ("Routing Basic")

Parameters
allowDisplayallowdisplay
void NXOpen::Routing::SplinePathBuilder::SetSplineMethod ( NXOpen::Positioning::Constraint::SplineType  splineMethod)

Sets the defining method of the spline.


Deprecated:
Deprecated in NX11.0.2. Use Routing::SplinePathBuilder::DefiningTypes instead.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
splineMethodthe defining method of the spline.
void NXOpen::Routing::SplinePathBuilder::SetStockBoundedDiameter ( double  value)

Sets the driving diameter of the current stock for the ratio-to-diameter bounded curvature.


Created in NX12.0.0.

License requirements : routing_advanced ("Routing Advanced")

Parameters
valuevalue
void NXOpen::Routing::SplinePathBuilder::SetUseMinimumCheckingValue ( bool  useMinRadius)

Sets whether the spline minimum radius value should be checked or not on this spline.


Created in NX9.0.1.

License requirements : routing_base ("Routing Basic")

Parameters
useMinRadiususeminradius
bool NXOpen::Routing::SplinePathBuilder::ShowSplineMinimumRadius ( )

Returns whether the spline minimum radius value should be displayed or not.


Created in NX9.0.1.

License requirements : routing_base ("Routing Basic")

void NXOpen::Routing::SplinePathBuilder::UnblankStocks ( )

Unblanks stocks which were blanked by calling BlankStockAndGetLargestDia

Deprecated:
Deprecated in NX12.0.0.

There is no need for this method.


Created in NX7.5.1.

License requirements : routing_base ("Routing Basic")

void NXOpen::Routing::SplinePathBuilder::UpdateDefiningPoint ( int  index,
NXOpen::Point point,
bool  inDrag,
const NXOpen::Vector3d translation 
)

Updates the position of a point on the spline.


Created in NX12.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
indexThe index of the point to update position..
pointThe point representing the new position.
inDragIs the point currently being dragged?
translationTranslation to redefine the point.
void NXOpen::Routing::SplinePathBuilder::UpdateDefiningPointPositionAtIndex ( int  index,
NXOpen::Point point,
bool  inDrag 
)

Updates the position of a point on the spline.


Created in NX6.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
indexThe index of the point to update position..
pointThe point representing the new position.
inDragIs the point currently being dragged?
void NXOpen::Routing::SplinePathBuilder::UpdateExtensionDirectionAtIndex ( int  index,
const NXOpen::Vector3d direction 
)

Update the extension orientation at the point index.


Created in NX12.0.0.

License requirements : routing_base ("Routing Basic")

Parameters
indexIndex of the point to analyze.
directionDirection to assign the extension.
void NXOpen::Routing::SplinePathBuilder::UpdateExtensionDirectionForPointAtIndex ( int  index,
const NXOpen::Vector3d deltaTrans,
const NXOpen::Matrix3x3 orientation,
bool  inDrag 
)

Update the extension orientation at the point index.


Created in NX11.0.1.

License requirements : routing_base ("Routing Basic")

Parameters
indexIndex of the point to analyze.
deltaTransTranslation to transform.
orientationDelta rotation transform.
inDragthe geometry is currently being dragged?
bool NXOpen::Routing::SplinePathBuilder::UseMinimumCheckingValue ( )

Returns whether the spline minimum radius value should be checked or not on this spline.


Created in NX9.0.1.

License requirements : routing_base ("Routing Basic")


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.